/*
 * Copyright (c) 2008-2022, Hazelcast, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#pragma once

#include <memory>

#include "hazelcast/util/export.h"
#include "hazelcast/util/Sync.h"
#include "hazelcast/client/monitor/local_map_stats.h"

#if defined(WIN32) || defined(_WIN32) || defined(WIN64) || defined(_WIN64)
#pragma warning(push)
#pragma warning(disable : 4251) // for dll export
#endif

namespace hazelcast {
namespace client {
namespace monitor {
namespace impl {
class HAZELCAST_API LocalMapStatsImpl : public local_map_stats
{
public:
    LocalMapStatsImpl();

    LocalMapStatsImpl(const std::shared_ptr<monitor::near_cache_stats>& stats);

    std::shared_ptr<monitor::near_cache_stats> get_near_cache_stats() const;

private:
    std::shared_ptr<monitor::near_cache_stats> near_cache_stats_;
};
} // namespace impl
} // namespace monitor
} // namespace client
} // namespace hazelcast

#if defined(WIN32) || defined(_WIN32) || defined(WIN64) || defined(_WIN64)
#pragma warning(pop)
#endif
